#import <Foundation/Foundation.h>

// messages the client will receive from the server
@protocol ChatterUsing

- (oneway void) showMessage: (in bycopy NSString *) message
 fromNickname: (in bycopy NSString *) nickname;

- (bycopy NSString *) nickname;

@end // ChatterUsing



// server will receive from the client
@protocol ChatterServing

- (oneway void) sendMessage: (in bycopy NSString *) message
 fromClient: (in byref id <ChatterUsing>) client;

// returns NO if someone aleady has the nickname
- (BOOL) subscribeClient: (in byref id <ChatterUsing>) newClient;

- (void) unsubscribeClient: (in byref id <ChatterUsing>) client;


@end // ChatterServing
